var makeUsersDeroulant = function() {
    try {
        $('.chosen-select, .usersDeroulant').chosen({
            no_results_text: 'Aucun résultat trouvé pour',
            allow_single_deselect: true,
            width: '100%',
            search_contains: true
        });
        // On s'assure de mettre à jour l'affichage si on change par programmation
        $('.chosen-select, .usersDeroulant').on('change', function (event) {
            // Pour le plugin jQuery chosen
            try {$(event.target).trigger('chosen:updated');} catch(e) {console.error(e);}
            // Voir aussi .multiSelect (plugin select2)
        });
    } catch(exception) {
        console.log(exception);
    }
};

$(document).ready(function () {
	try {
		$('#modalNotif').modal();
	} catch(exception) {
		console.log(exception);
	}

    makeUsersDeroulant();

	try {
		$('.my-tooltip').tooltip({
			delay: {
			    'show': 800,
                'hide': 0
            },
			container: 'body'
		});
	} catch(exception) {
		console.log(exception);
	}

    $('[id^="collapse"]').on('shown.bs.collapse', function () {
        var coucou = $(this).attr('id');
        $('html, body').animate({
            scrollTop: $('#' + coucou).offset().top - 100
        }, 'fast');
        return false;
    });

    $('.btn-del-file').click(function () {
        var value = $(this).attr('data');
        $('.tr-file-' + value).css('color', '#d3d3d3');
        $('.boutonsFile' + value).hide();
        $('.boutonsFileHide' + value).show();
        var newElement = jQuery('<input type="hidden" class="hiddenFile' + value + '" name="delfiles[]" value="' + value + '"/>');
        $('.hiddenfields').append(newElement);
    });

    $('.btn-cancel-file').click(function () {
        var value = $(this).attr('data');
        $('.tr-file-' + value).css('color', '#000000');
        $('.boutonsFileHide' + value).hide();
        $('.boutonsFile' + value).show();
        $('.hiddenFile' + value).remove();

    });

    $('.btn-edit-registre').click(function () {
        var id = $(this).attr('data');
        $('#idEditRegistre').val(id);
    });

    $('.btn-insert-registre').click(function () {
        var id = $(this).attr('data-id');
        $('#idFiche').val(id);
        
        var normeId = $(this).attr('data-norme-id');
        $('#norme').val(normeId).trigger('chosen:updated');

        if ($(this).attr('data-type') === 'false'){
            $('#typedeclaration').parent().parent().show();
        } else{
            $('#typedeclaration').parent().parent().hide();
        }

    });

    $('.btn_envoyerValideur').click(function () {
        var id = $(this).attr('data-id');
        $('#ficheNumVal').val(id);

        var fiche = $(this).attr('data-fiche');
        $('#etatFicheVal').val(fiche);
    });

    $('.btn_envoyerConsultation').click(function () {
        var id = $(this).attr('data-id');
        $('#ficheNumCons').val(id);

        var fiche = $(this).attr('data-fiche');
        $('#etatFicheCons').val(fiche);
    });

    $('.btn_ReorienterTraitement').click(function () {
        var id = $(this).attr('data-id');
        $('#ficheNumReo').val(id);

        var fiche = $(this).attr('data-fiche');
        $('#etatFicheReo').val(fiche);
    });

    $('.btn-upload-modele').click(function () {
        var id = $(this).attr('data');
        $('#idUploadModele').val(id);
    });

    $('.btn_DuplicationTraitementOrganisations').click(function () {
        var id = $(this).attr('data-id');
        $('#fiche_id').val(id);
    });

    // Défauts pour le plugin jQuery filestyle
    $.fn.filestyle.defaults['buttonText'] = 'Parcourir';
    $.fn.filestyle.defaults['iconName'] = 'fa fa-folder-open fa-lg';
    $.fn.filestyle.defaults['buttonName'] = 'btn btn-default-primary';
});

function openTarget(idFicheNotification) {
    var scrollToTarget = function (idFicheNotification) {
        $('html, body').animate({scrollTop: $('#btnHistorique' + idFicheNotification).offset().top - 90}, 1000);
        if (idFicheNotification !== 0) {
            $('#btnHistorique' + idFicheNotification).click();
        }
    };
    
    if (idFicheNotification) {
        scrollToTarget(idFicheNotification);
    }
}

function verificationExtension() {
    $('#fileAnnexe').change(function () {
        var annexes = this.files;

        for (var i = 0; i< annexes.length; i++ ) {
            var tmpName = annexes[i]['name'];

            if (tmpName !== '') {
                //suppression du fakepath ajouter par webkit
                tmpName = tmpName.replace("C:\\fakepath\\", "");

                //verification de l'extension odt OU pdf
                var ctrlName = tmpName.split('.');

                if (ctrlName[ctrlName.length - 1] !== 'odt' && ctrlName[ctrlName.length - 1] !== 'pdf') {
                    $(this).val('');
                    $('#errorExtentionAnnexe').modal('show');
                }
            }
        }
    });
}

var WebcilForm = {
	chosenFields: function(form) {
		var selects;
		if (true === $.isFunction( $.fn.chosen )) {
			try {
				selects = $(form).find('select').chosen();
			} catch(exception) {
				selects = [];
			}
		} else {
			selects = [];
		}

		return $(selects);
	},
	reset: function(event) {
		var form = $(event.target).closest('form'),
			typesWithValue = ['color',
                'date',
                'datetime',
                'email',
                'month',
                'number',
                'password',
                'range',
                'research',
                'search',
                'tel',
                'text',
                'url',
                'week'
            ];
			typesWithChecked = ['checkbox', 'radio'];
			fieldsWithValue = $(form).find(
			    'input[type="'+typesWithValue.join('"], input[type="')+'"]'+', select, textarea'
            );
			fieldsWithChecked = $(form).find(
			    'input[type="'+typesWithChecked.join('"], input[type="')+'"]'
            );

		$(fieldsWithValue).val('');
		$(fieldsWithValue).trigger('change');

		$(fieldsWithChecked).prop('checked', false);
		$(fieldsWithValue).trigger('click');

		// On indique au plugin chosen qu'il doit mettre à jour les champs
		WebcilForm.chosenFields(form).trigger('chosen:updated');

		event.preventDefault();
		event.stopPropagation();
	},
	init: function(form) {
		$(form).find('.search-reset').bind('click', WebcilForm.reset);

		WebcilForm.chosenFields(form).each(function(idx, select){
			var chosen = $('#'+$(select).attr('id')+'_chosen'),
				span = $(chosen).find('a.chosen-single.chosen-default span');

			$(select).on('change', function(event, params) {
				if('undefined' === typeof params) {
					$(span).addClass('text-muted');
				} else {
					$(span).removeClass('text-muted');
				}
			});

			$(span).addClass('text-muted');
		});
	}
};

$(function(){
	$('form.search-form').each(function(idx, form){
	    WebcilForm.init(form);
	});
});

/*
La touche "Entree" du clavier n'a plus d'action
sauf sur les grand champs texte pour aller à la ligne
*/
$(document).on('keydown', ':input:not(textarea)', function(event) {
    if (event.key == 'Enter') {
        event.preventDefault();
    }
});
// document.addEventListener("keydown", function(event) {
//     if (event.keyCode == 13) {
//         event.preventDefault();
//         return false;
//     }
// }, true);
